<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWSEntryTerminal ArrayType
 * @subpackage Arrays
 */
class ArrayOfWSEntryTerminal extends AbstractStructArrayBase
{
    /**
     * The WSEntryTerminal
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WSEntryTerminal[]
     */
    public $WSEntryTerminal;
    /**
     * Constructor method for ArrayOfWSEntryTerminal
     * @uses ArrayOfWSEntryTerminal::setWSEntryTerminal()
     * @param \StructType\WSEntryTerminal[] $wSEntryTerminal
     */
    public function __construct(array $wSEntryTerminal = array())
    {
        $this
            ->setWSEntryTerminal($wSEntryTerminal);
    }
    /**
     * Get WSEntryTerminal value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WSEntryTerminal[]|null
     */
    public function getWSEntryTerminal()
    {
        return isset($this->WSEntryTerminal) ? $this->WSEntryTerminal : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWSEntryTerminal method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWSEntryTerminal method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWSEntryTerminalForArrayConstraintsFromSetWSEntryTerminal(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWSEntryTerminalWSEntryTerminalItem) {
            // validation for constraint: itemType
            if (!$arrayOfWSEntryTerminalWSEntryTerminalItem instanceof \StructType\WSEntryTerminal) {
                $invalidValues[] = is_object($arrayOfWSEntryTerminalWSEntryTerminalItem) ? get_class($arrayOfWSEntryTerminalWSEntryTerminalItem) : sprintf('%s(%s)', gettype($arrayOfWSEntryTerminalWSEntryTerminalItem), var_export($arrayOfWSEntryTerminalWSEntryTerminalItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WSEntryTerminal property can only contain items of type \StructType\WSEntryTerminal, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WSEntryTerminal value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WSEntryTerminal[] $wSEntryTerminal
     * @return \ArrayType\ArrayOfWSEntryTerminal
     */
    public function setWSEntryTerminal(array $wSEntryTerminal = array())
    {
        // validation for constraint: array
        if ('' !== ($wSEntryTerminalArrayErrorMessage = self::validateWSEntryTerminalForArrayConstraintsFromSetWSEntryTerminal($wSEntryTerminal))) {
            throw new \InvalidArgumentException($wSEntryTerminalArrayErrorMessage, __LINE__);
        }
        if (is_null($wSEntryTerminal) || (is_array($wSEntryTerminal) && empty($wSEntryTerminal))) {
            unset($this->WSEntryTerminal);
        } else {
            $this->WSEntryTerminal = $wSEntryTerminal;
        }
        return $this;
    }
    /**
     * Add item to WSEntryTerminal value
     * @throws \InvalidArgumentException
     * @param \StructType\WSEntryTerminal $item
     * @return \ArrayType\ArrayOfWSEntryTerminal
     */
    public function addToWSEntryTerminal(\StructType\WSEntryTerminal $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WSEntryTerminal) {
            throw new \InvalidArgumentException(sprintf('The WSEntryTerminal property can only contain items of type \StructType\WSEntryTerminal, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WSEntryTerminal[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WSEntryTerminal|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WSEntryTerminal|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WSEntryTerminal|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WSEntryTerminal|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WSEntryTerminal|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WSEntryTerminal
     */
    public function getAttributeName()
    {
        return 'WSEntryTerminal';
    }
}
