<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWSTerminalModification ArrayType
 * @subpackage Arrays
 */
class ArrayOfWSTerminalModification extends AbstractStructArrayBase
{
    /**
     * The WSTerminalModification
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WSTerminalModification[]
     */
    public $WSTerminalModification;
    /**
     * Constructor method for ArrayOfWSTerminalModification
     * @uses ArrayOfWSTerminalModification::setWSTerminalModification()
     * @param \StructType\WSTerminalModification[] $wSTerminalModification
     */
    public function __construct(array $wSTerminalModification = array())
    {
        $this
            ->setWSTerminalModification($wSTerminalModification);
    }
    /**
     * Get WSTerminalModification value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WSTerminalModification[]|null
     */
    public function getWSTerminalModification()
    {
        return isset($this->WSTerminalModification) ? $this->WSTerminalModification : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWSTerminalModification method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWSTerminalModification method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWSTerminalModificationForArrayConstraintsFromSetWSTerminalModification(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWSTerminalModificationWSTerminalModificationItem) {
            // validation for constraint: itemType
            if (!$arrayOfWSTerminalModificationWSTerminalModificationItem instanceof \StructType\WSTerminalModification) {
                $invalidValues[] = is_object($arrayOfWSTerminalModificationWSTerminalModificationItem) ? get_class($arrayOfWSTerminalModificationWSTerminalModificationItem) : sprintf('%s(%s)', gettype($arrayOfWSTerminalModificationWSTerminalModificationItem), var_export($arrayOfWSTerminalModificationWSTerminalModificationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WSTerminalModification property can only contain items of type \StructType\WSTerminalModification, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WSTerminalModification value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WSTerminalModification[] $wSTerminalModification
     * @return \ArrayType\ArrayOfWSTerminalModification
     */
    public function setWSTerminalModification(array $wSTerminalModification = array())
    {
        // validation for constraint: array
        if ('' !== ($wSTerminalModificationArrayErrorMessage = self::validateWSTerminalModificationForArrayConstraintsFromSetWSTerminalModification($wSTerminalModification))) {
            throw new \InvalidArgumentException($wSTerminalModificationArrayErrorMessage, __LINE__);
        }
        if (is_null($wSTerminalModification) || (is_array($wSTerminalModification) && empty($wSTerminalModification))) {
            unset($this->WSTerminalModification);
        } else {
            $this->WSTerminalModification = $wSTerminalModification;
        }
        return $this;
    }
    /**
     * Add item to WSTerminalModification value
     * @throws \InvalidArgumentException
     * @param \StructType\WSTerminalModification $item
     * @return \ArrayType\ArrayOfWSTerminalModification
     */
    public function addToWSTerminalModification(\StructType\WSTerminalModification $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WSTerminalModification) {
            throw new \InvalidArgumentException(sprintf('The WSTerminalModification property can only contain items of type \StructType\WSTerminalModification, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WSTerminalModification[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WSTerminalModification|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WSTerminalModification|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WSTerminalModification|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WSTerminalModification|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WSTerminalModification|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WSTerminalModification
     */
    public function getAttributeName()
    {
        return 'WSTerminalModification';
    }
}
