<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for WSEntryException StructType
 * @subpackage Structs
 */
class WSEntryException extends AbstractStructBase
{
    /**
     * The cardList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfWSKeyValue
     */
    public $cardList;
    /**
     * The days
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfWSEntryExceptionDay
     */
    public $days;
    /**
     * The flags
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfWSKeyValue
     */
    public $flags;
    /**
     * Constructor method for WSEntryException
     * @uses WSEntryException::setCardList()
     * @uses WSEntryException::setDays()
     * @uses WSEntryException::setFlags()
     * @param \ArrayType\ArrayOfWSKeyValue $cardList
     * @param \ArrayType\ArrayOfWSEntryExceptionDay $days
     * @param \ArrayType\ArrayOfWSKeyValue $flags
     */
    public function __construct(\ArrayType\ArrayOfWSKeyValue $cardList = null, \ArrayType\ArrayOfWSEntryExceptionDay $days = null, \ArrayType\ArrayOfWSKeyValue $flags = null)
    {
        $this
            ->setCardList($cardList)
            ->setDays($days)
            ->setFlags($flags);
    }
    /**
     * Get cardList value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfWSKeyValue|null
     */
    public function getCardList()
    {
        return isset($this->cardList) ? $this->cardList : null;
    }
    /**
     * Set cardList value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfWSKeyValue $cardList
     * @return \StructType\WSEntryException
     */
    public function setCardList(\ArrayType\ArrayOfWSKeyValue $cardList = null)
    {
        if (is_null($cardList) || (is_array($cardList) && empty($cardList))) {
            unset($this->cardList);
        } else {
            $this->cardList = $cardList;
        }
        return $this;
    }
    /**
     * Get days value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfWSEntryExceptionDay|null
     */
    public function getDays()
    {
        return isset($this->days) ? $this->days : null;
    }
    /**
     * Set days value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfWSEntryExceptionDay $days
     * @return \StructType\WSEntryException
     */
    public function setDays(\ArrayType\ArrayOfWSEntryExceptionDay $days = null)
    {
        if (is_null($days) || (is_array($days) && empty($days))) {
            unset($this->days);
        } else {
            $this->days = $days;
        }
        return $this;
    }
    /**
     * Get flags value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfWSKeyValue|null
     */
    public function getFlags()
    {
        return isset($this->flags) ? $this->flags : null;
    }
    /**
     * Set flags value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfWSKeyValue $flags
     * @return \StructType\WSEntryException
     */
    public function setFlags(\ArrayType\ArrayOfWSKeyValue $flags = null)
    {
        if (is_null($flags) || (is_array($flags) && empty($flags))) {
            unset($this->flags);
        } else {
            $this->flags = $flags;
        }
        return $this;
    }
}
